extensions [ sound ]
globals [ 
  groupe communal
  maize-price-variation peanut-price-variation manioc-blanc-price-variation coffee-price-variation
  maize-yield-variation peanut-yield-variation coffee-yield-variation manioc-blanc-yield-variation
  months hour-in-day day-in-week weekdays-text weekdays 
  day-in-month day-in-year month-in-year month-text year 
  stop-for-decision question-id
  coffee-store manioc-rouge-store manioc-blanc-store okra-store huile-de-palm-store melon-store maize-store peanut-store 
  hectare-yield-maize hectare-yield-manioc-rouge hectare-yield-manioc-blanc hectare-yield-peanut hectare-yield-melon hectare-yield-okra hectare-yield-huile-de-palm hectare-yield-coffee
  price-maize price-manioc-rouge price-manioc-blanc price-melon price-peanut price-coffee price-huile-de-palm price-okra
  rain-data-1961-2000
  rain-data-2046-2065 
  rain-data-2081-2100
  temperature-data-20th-century
  temperature-data-2046-2065
  temperature-data-2081-2100 
  choice-of-field ; bit of a hack 
  pace-preparing-soil-with-tractor
  ]
patches-own [ use crop state water-content communally-owned? time-til-last-prepared-in-weeks ]
breed [ farmers farmer ]
breed [ store ]
breed [ clouds cloud ]
breed [ cars car ]
breed [ fences fence ]
breed [ monuments monument ]
breed [ trees tree ]
breed [ houses house ]
breed [ catholic-churches church ]
breed [ protestant-churches church ]
breed [ mosques mosque ]
breed [ dispensaries dispensary ]
breed [ markets market ]
breed [ schools school ]
breed [ cows cow ]
breed [ lights light ]
breed [ music-notes music-note ]
breed [ tractors tractor ]
breed [ coffees coffee ]
breed [ maizes maize ]
breed [ melons melon ]
breed [ manioc-rouges manioc-rouge ]
breed [ manioc-blancs manioc-blanc ]
breed [ okras okra ]
breed [ huile-de-palms huile-de-palm ]
breed [ harvested-maizes harvested-maize ]
breed [ burning-maizes burning-maize ]
breed [ peanuts peanut ]
coffees-own [ time-to-mature age-weeks yield harvested-this-year ]
maizes-own [ time-to-mature age-weeks yield harvested? harvested-this-year]
manioc-rouges-own [ time-to-mature age-weeks yield harvested-this-year ]
manioc-blancs-own [ time-to-mature age-weeks yield harvested-this-year ]
peanuts-own [ time-to-mature age-weeks yield harvested-this-year ]
melons-own [ time-to-mature age-weeks yield harvested-this-year ]
huile-de-palms-own [ time-to-mature age-weeks yield harvested-this-year ]
okras-own [ time-to-mature age-weeks yield harvested-this-year ]
burning-maizes-own [ spark? ]
farmers-own [ crop-today action pace-preparing-soil pace-sowing-seed pace-harvesting-crop my-home driver? health ]
cows-own [ wandering? target ]
tractors-own [ hired-duration crop-today ]
houses-own [ account household-threshold ]
clouds-own [ rain-mm ]
cars-own [ driving? age ]
lights-own [ age ]
music-notes-own [ age ]
to setup
  ca
  initialise-yields
  initialise-prices
  set hour-in-day 1
  set day-in-week 1
  set day-in-month 1
  set month-in-year 1
  set day-in-year 1
  import-pcolors-rgb "a10.png" 
  read-in-climate-model-weather-data
  set groupe "grand famille"
  set communal 2 * 300 ; 2 hectares
  output-print "OxGAME (Games for Agent Modelling Enquiries) project" ; opening message
  output-print "BIENVENUE au jeu de l'agriculture!" ; opening message
  output-print "Appuyer ALLER pour commencer."
  set weekdays [ "lundi" "mardi" "mecredi" "jeudi" "vendredi" "samedi" "dimanche" ]
  set months [ "janv" "févr" "mars" "avril" "mai" "juin" "juil" "août" "sept" "oct" "nov" "déc" ]
  set stop-for-decision 1
  assign-land-use
  ask patches [ if use = "forest" and random 50 > 48 [ sprout-trees 1 [ set color [ 0 255 0 200 ] set shape "tree" set size 5 ] ] ]
  set coffee-store 0
  set manioc-rouge-store 0
  set manioc-blanc-store 0
  set okra-store 0
  set huile-de-palm-store 0
  set melon-store 0
  set maize-store 2
  set peanut-store 1
  create-houses 1 [ 
    set account 60000
    set label-color pink
    set shape "house"
    set color brown
    set label "Maison"
    set label-color blue
    set size 8
    set household-threshold -20000
    move-to max-one-of patches with [ use = "garden plot"] [ pycor ]
  ]
  if groupe = "grand famille" [
    create-farmers 4 [
      set shape "person farmer"
      set size 3
      set color brown
      move-to one-of houses
      set my-home min-one-of houses [ distance myself ]
      fd 5
      set pace-preparing-soil 2
      set pace-sowing-seed 3
      set pace-harvesting-crop 5
    ]
  ]
  create-cows 5 [
    set wandering? false
    set shape "cow"
    set size 3
    set color 31 + random 7
    move-to one-of patches with [ use = "wilds" ]
  ]
  set pace-preparing-soil-with-tractor 10
  file-open "my-file-in2.txt"
  reset-ticks
end

to GO
  clock
  file-print ( word ticks "," [ account ] of one-of houses )
  add-disasters
  parties
  seasonal-price-variation
  yield-variation
  eat
  crops-age
  ifelse cars? = true 
  [ 
    if not any? cars [ create-cars 1 [ set color blue set shape "truck cab top" set size 5 set age 100 move-to one-of patches with [ use = "road" ] ] ]
    ]
  [ 
    if any? cars [ ask cars [ die ] ] 
    ]
  drive-cars
  ask farmers [ if any? houses-here [ set heading random 360 fd random-float 1 ] ]
  decisions
  clouds-form-and-blow-across
  calendar
  seeds-grow
  fire-spreads
  cow-movement
  ask cows [ if ticks mod 672 = 0 and ticks > 24 [ set wandering? true ] ]
  make-lots-of-png-images
  tick
end

to seasonal-price-variation
  ifelse member? month-text [ "avril" "mai" "juin" "juil" ] and day-in-month = 5 and hour-in-day = 1
  [
    set maize-price-variation 1
  ]
  [
    set maize-price-variation 0
  ]
  
  ifelse member? month-text [ "avril" "mai" "juin" "juil" ] and day-in-month = 5 and hour-in-day = 1
  [
    set coffee-price-variation 1
  ]
  [
    set coffee-price-variation 0
  ]
  
  ifelse member? month-text [ "avril" "mai" "juin" "juil" ] and day-in-month = 5 and hour-in-day = 1
  [
    set manioc-blanc-price-variation 1
  ]
  [
    set manioc-blanc-price-variation 0
  ]
  
  ifelse member? month-text [ "avril" "mai" "juin" "juil" ] and day-in-month = 5 and hour-in-day = 1
  [
    set peanut-price-variation 1
  ]
  [
    set peanut-price-variation 0
  ]
  
end

to yield-variation
  if day-in-month = 5 and hour-in-day = 1 [
    ifelse random 10 >= 5 
    [
      set maize-yield-variation 0
      ]
    [
      set maize-yield-variation 0
    ]
    ifelse random 10 >= 5
    [
      set peanut-yield-variation 0
      ]
    [
      set peanut-yield-variation 0
      ]
    ifelse random 10 >= 5
    [
      set manioc-blanc-yield-variation 0
      ]
    [
      set manioc-blanc-yield-variation 0
      ]
    ]
end

to eat
  ; 12 mouths eat a bucket of maize per week and a bucket of one of the other crops (chosen at random) except coffee
  if ticks mod 168 = 0 [
    set maize-store maize-store - ( 1 / 7 )
    ; to do: take some food from another part of store each week
  ]
end

to parties
  ;; months: "janv" "févr" "mars" "avril" "mai" "juin" "juil" "août" "sept" "oct" "nov" "déc"
  if month-text = "déc" and day-in-month = 25 and hour-in-day = 20 [ ; it is Xmas
    clear-output
    output-print "Jour ferier! Vous-avez payer 5000 pour des habits et de la biere"
    ask one-of houses [ set account account - 5000 ]
  ]
  if month-text = "janv" and day-in-month = 1 and hour-in-day = 20 [ ; it is Xmas
    clear-output
    output-print "Jour ferier! Vous-avez payer 5000 pour des habits et de la biere"
    ask one-of houses [ set account account - 5000 ]
  ]
  if month-text = "févr" and day-in-month = 11 and hour-in-day = 20 [ ; it is Xmas
    clear-output
    output-print "Jour ferier! Vous-avez payer 5000 pour des habits et de la biere"
    ask one-of houses [ set account account - 5000 ]
  ]
  if month-text = "mai" and day-in-month = 1 and hour-in-day = 20 [ ; it is Xmas
    clear-output
    output-print "Jour ferier! Vous-avez payer 5000 pour des habits et de la biere"
    ask one-of houses [ set account account - 5000 ]
  ]  
  if month-text = "avril" and day-in-month = 15 and hour-in-day = 20 [ ; it is Xmas
    clear-output
    output-print "Jour ferier! Vous-avez payer 5000 pour des habits et de la biere"
    ask one-of houses [ set account account - 5000 ]
  ]
  if month-text = "mai" and day-in-month = 20 and hour-in-day = 20 [ ; it is Xmas
    clear-output
    output-print "Jour ferier! Vous-avez payer 5000 pour des habits et de la biere"
    ask one-of houses [ set account account - 5000 ]
  ]
  if month-text = "août" and day-in-month = 15 and hour-in-day = 20 [ ; it is Xmas
    clear-output
    output-print "Jour ferier! Vous-avez payer 5000 pour des habits et de la biere"
    ask one-of houses [ set account account - 5000 ]
  ]
  if month-text = "juin" and day-in-month = 1 and hour-in-day = 20 [ ; it is ramadan
    clear-output
    output-print "Jour ferier! Vous-avez payer 5000 pour des habits et de la biere"
    ask one-of houses [ set account account - 5000 ]
  ]
  if month-text = "juin" and day-in-month = 30 and hour-in-day = 20 [ ; it is ramadan
    clear-output
    output-print "Jour ferier! Vous-avez payer 5000 pour des habits et de la biere"
    ask one-of houses [ set account account - 5000 ]
  ]
end

to clouds-form-and-blow-across
  if ticks mod 24 = 0 [
    let a round item ( month-in-year - 1 ) rain-data-1961-2000
    ask patches [ set water-content a ]
    if nuages? = true [
      create-clouds round a [
        set shape "cloud"
        set size 20
        set color [ 0 0 50 20 ]
        set heading 315
        ifelse random 10 > 5
        [
          move-to one-of patches with [ pycor = min-pycor and pxcor > 0 ]
        ]
        [
          move-to one-of patches with [ pxcor = max-pxcor and pycor < 0 ]
        ]
        jump random-exponential 10
      ]
    ]
  ]
  if any? clouds [ 
    ask clouds [
      set heading 315 - random 30
      fd random-float 5
      if pycor >= max-pycor - 5 [ die ]
      if pxcor <= min-pxcor + 5 [ die ]
    ]
  ]
end

to PREPARE-COMMUNAL-FIELD
  ask farmers with [ action = "prepare-communal-field" ] [
      clear-communal-field
      return-from-communal-field
    ] 
end

to clear-communal-field
  let work-to-do count patches with [ use = "farmland" and state = "wild" and communally-owned? = true ]
  if hour-in-day = 8 and work-to-do >= 1 [
    move-to min-one-of patches with [ use = "farmland" and state = "wild" and communally-owned? = true ] [ distance myself ]
    ifelse work-to-do >= pace-preparing-soil
      [
        ask min-n-of pace-preparing-soil patches with [ use = "farmland" and communally-owned? = true ] [ distance myself ] [
          set state "prepared"
          set pcolor 32 ]
        ]
      [
        ask min-n-of work-to-do patches with [ use = "farmland" and communally-owned? = true ] [ distance myself ] [
          set state "prepared"
          set pcolor 32 ]
        ]
  ]
end

to return-from-communal-field
  if hour-in-day = 20 [
    move-to my-home
    set action 0
    ]  
end

to SOW-COMMUNAL-FIELD
  if hour-in-day = 8 [
    ask farmers with [ action = "sow-communal-field" and health >= 0 ] [
      if any? patches with [ communally-owned? = true and state = "prepared" and not any? maizes-here ] [
        move-to min-one-of patches with [ communally-owned? = true and state = "prepared" and not any? maizes-here ] [ distance myself ]
        let work-to-do count patches with [ communally-owned? = true and state = "prepared" and not any? maizes-here ]
        ifelse work-to-do >= pace-sowing-seed
        [
          ask min-n-of pace-sowing-seed patches with [ communally-owned? = true and state = "prepared" and not any? maizes-here ] [ distance myself ] [
            sprout-maizes 1 [ set time-to-mature 12 set shape "plant" set color 44 set size .5 ]
            set state "seeded"
          ]
        ]
        [
          ask min-n-of work-to-do patches with [ communally-owned? = true and state = "prepared" and not any? maizes-here ] [ distance myself ] [
            sprout-maizes 1 [ set time-to-mature 12 set shape "plant" set color 44 set size .5 ]
            set state "seeded"
          ]
        ]
      ]
    ]
  ]
  if hour-in-day = 20 [ 
     ask farmers [ set action 0 ] ]
end
        
to PREPARE-SOIL
  ask farmers with [ action = "prepare-soil" and health >= 0 ] [
      clear-my-fields
      return-from-field
    ] 
end

to clear-my-fields
  if hour-in-day = 8 [
    let work-to-do count patches with [ member? use [ "farmland" "forest" ] and state = "wild" and communally-owned? = 0 ] 
    if work-to-do >= 1 [
      if any? patches with [ member? use [ "farmland" "forest" ] and state = "wild" and crop != 0 and communally-owned? = 0 ] [ 
        let choice-today min-one-of patches with [ member? use [ "farmland" "forest" ] and state = "wild" and crop != 0 and communally-owned? = 0 ] [ distance myself ]
        move-to choice-today  
        ifelse work-to-do >= pace-preparing-soil
        [
          ask min-n-of pace-preparing-soil patches with [ member? use [ "farmland" "forest" ] and state = "wild" and communally-owned? = 0 ] [ distance myself ] [
            set state "prepared"
            set pcolor 32 ]
          ]
        [
          ask min-n-of work-to-do patches with [ member? use [ "farmland" "forest" ] and state = "wild" and communally-owned? = 0 ] [ distance myself ] [
            set state "prepared"
            set pcolor 32 ]
          ]
      ]
    ]
  ]        
end

to return-from-field
  if hour-in-day = 18 [
    move-to my-home
    set action 0
    ]  
end

to SOCIALISE
  ask farmers [
    if action = "socialise" [
      go-to-village-square
      mill-around-square
      return-home
    ]
  ] 
end

to go-to-village-square
  if hour-in-day = 6 [ move-to one-of patches with [ use = "village square" ] ]
end
  
to mill-around-square
  if hour-in-day > 6 and hour-in-day < 18 [
    if ticks mod 5 = 0 [ 
      move-to one-of neighbors with [ use = "village square" ] ]
  ]
end

to return-home
  if hour-in-day = 18 [ 
    move-to my-home
    set action 0 ]
end

to WORSHIP
  ask farmers [
    if action = "worship" [
      go-religious-building
      sing-prey-learn
      return-home
    ]
  ] 
end

to go-religious-building
  if hour-in-day = 6 [ 
    move-to min-one-of turtles with [ member? breed ( list catholic-churches protestant-churches mosques ) ] [ distance myself ] 
  ]
end

to sing-prey-learn
  hatch-music-notes 1 [
    set shape "music notes 1" set size 1 + random-float 1 set color random 255 set heading 0 ]
  if any? music-notes [
    ask music-notes [
      set age age + 1
      if age >= 10 [ die ]
      set heading heading + 20 - random 40
      fd random-float 2 ]
    ]
end

to SHOP
  ask farmers [
    if action = "shop" [
      go-to-market
      mill-around-market
      return-home
    ]
  ] 
end

to go-to-market
  if hour-in-day = 6 [ 
    move-to min-one-of markets [ distance myself ] ]
end

to mill-around-market
  ifelse distance one-of markets <= 10
  [
    fd 1
    rt random 360 
    ]
  [
    move-to min-one-of markets [ distance myself ] 
    ]
end

to assign-land-use
  ask patches [
    if pcolor = [22 99 1] [ set use "forest" set pcolor 62 set state "wild" ]
    if pcolor = [236 210 65] [ set use "village" set pcolor 48 ]
    if pcolor = [226 201 67] [ set use "mosque site" set pcolor 47 ]
    if pcolor = [232 145 7] [ set use "chefferie" set pcolor 47 ]
    if pcolor = [233 206 69] [ set use "garden plot" set pcolor [233 206 69] ]
    if pcolor = [162 104 12] [ set use "dispensary site" set pcolor 47 ]
    if pcolor = [128 113 90] [ set use "catholic church site" set pcolor 47 ]
    if pcolor = [205 161 92] [ set use "protestant church site" set pcolor 47 ]
    if pcolor = [236 196 132] [ set use "market site" set pcolor 47 ]
    if pcolor = [191 178 157] [ set use "school site" set pcolor 47 ]
    if pcolor = [140 76 41] [ set use "road" set pcolor 47 ]
    if pcolor = [160 81 38] [ set use "little road" set pcolor 48.5 ]
    if pcolor = [42 210 20] [ set use "farmland" set pcolor 52 set state "wild" ]
    if pcolor = [41 41 140] [ set use "river" set pcolor blue ]
    if pcolor = [78 124 72] [ set use "wilds" set pcolor 52 ]
  ]
  let a 52 + random-float 5
  ask max-n-of ( 2 * 300 ) patches with [ use = "farmland" and crop = 0 ] [ pycor ] [
    set communally-owned? true
    set state "wild"
    set crop "maize"
    set pcolor a ]
  ask one-of patches with [ communally-owned? = true and any? neighbors with [ use = "river" ] and pycor < ( max-pycor - 2 )] [ set plabel "champs communaux" ]
  ask one-of patches with [ use = "chefferie" ] [ sprout-monuments 1 [ 
      set shape "chess pawn" set size 6 set label "chefferie" set label-color blue 
      move-to max-one-of patches with [ use = "chefferie" ] [ pycor ] ] ]
  ask one-of patches with [ use = "school site" ] [ sprout-schools 1 [ 
      set shape "house colonial" set size 6 set label "L'ecole" set label-color blue
      move-to max-one-of patches with [ use = "school site" ] [ pycor ] ] ]
  ask one-of patches with [ use = "market site" ] [ sprout-markets 1 [ 
      set shape "chess king" set heading 0 set size 5 set label "marché" set label-color blue
      move-to min-one-of patches with [ use = "market site" ] [ pycor ] ] ]
  ask one-of patches with [ use = "catholic church site" ] [ sprout-catholic-churches 1 [ 
      set shape "chess rook" set heading 0 set size 5 set label "église catholic" set label-color blue
      move-to max-one-of patches with [ use = "catholic church site" ] [ pycor ] ] ]
  ask one-of patches with [ use = "protestant church site" ] [ sprout-protestant-churches 1 [ 
      set shape "chess rook" set heading 0 set size 5 set label "église protestant" set label-color blue
      move-to max-one-of patches with [ use = "protestant church site" ] [ pycor ] ] ]
  ask one-of patches with [ use = "mosque site" ] [ sprout-mosques 1 [ 
      set shape "chess bishop" set heading 0 set size 5 set label "mosque" set label-color blue
      move-to max-one-of patches with [ use = "mosque site" ] [ pycor ] ] ]
  ask one-of patches with [ use = "dispensary site" ] [ 
    sprout 1 [ 
      set shape "building store" set heading 0 set size 5 set label "dispensaire" set label-color blue
      move-to max-one-of patches with [ use = "dispensary site" ] [ pycor ] ] ] 
end

to seeds-grow
  if ticks mod 720 = 0 [
    if any? turtles with [ member? breed ( list coffees maizes peanuts melons manioc-rouges manioc-blancs ) and size <= 1 ] [
      ask turtles with [ member? breed ( list coffees maizes peanuts melons manioc-rouges manioc-blancs ) and size <= 1 ] [
        set size size + 1 ] ] ]
  if ticks mod 720 = 0 [
    if any? huile-de-palms [
      ask huile-de-palms [
        if size <= 2 [ 
            set size size + 2  ] ] ]
  ]
end

to DECISIONS
  if ticks mod 8640 = 0 [ 
    if ticks > 1 [ ask patches with [ member? use (list "farmland" "forest") and not any? turtles-here ] [ set pcolor 52 set crop 0 set state "wild" set plabel "" ] ]
    clear-output
    output-print "Choisi le superficie de chaque culture a cultiver cette annee."
    output-print "Quand vous-avez choisi, appuyer A pour continuer."
    output-print "Appuyer B pour commencer encore."
    set question-id 1
    set stop-for-decision 0 ]
  if ticks = 2 [ 
    clear-output
    output-print "Vous prenez combien de jour par mois pour "
    output-print "le travaille communautaire?"
    output-print "Choisi le numero de jours et puis,"
    output-print "appuyer A pour continuer."
    set question-id 2
    set stop-for-decision 0 ]
  if ticks = 3 [ 
    clear-output
    output-print "(Vous pouvez ralentir et accélérer le modèle!)"
    output-print "Appuyer A pour continuer."
    set question-id 3
    set stop-for-decision 0 ]
  if maize-store <= 0 [
    clear-output
    output-print "Vous n'avez-pas de maïs "
    output-print "Il faux acheter, et puis"
    output-print "appuyer A pour continuer."
    set question-id 4
    set stop-for-decision 0 ]
  if [ account ] of one-of houses <= [ household-threshold ] of one-of houses [
    clear-output
    output-print "Vous n'avez plus de l'argent!"
    output-print "Vender quelque-chose et appuyer A,"
    output-print "Ou appuyer INSTALLER pour recommencer encore."
    set question-id 5
    set stop-for-decision 0
  ]     
end

to ANSWER [ a-id ]
    if question-id = 1 [
      if a-id = 0 [
        clear-output
        set stop-for-decision 1 ] ]
    if question-id = 1 [
      if a-id = 1 [
        ask patches with [ state = "wild" and communally-owned? = 0 ] [
          set crop 0
          set pcolor 52
          set plabel "" ]
        if any? trees with [ member? label (list "cafe" "huile de palme") ] [
        ask trees with [ member? label (list "cafe" "huile de palme") ] [
          if [ state ] of patch-here = "wild" [ set label "" ]
        ] ] ]
    ]   
    if question-id = 2 [
      if a-id = 0 or a-id = 1 or a-id = 2 [ 
        set stop-for-decision 1 
        clear-output ] ]
    if question-id = 3 [
      if a-id = 0 or a-id = 1 or a-id = 2 [ 
        set stop-for-decision 1 
        clear-output ] ]
    if question-id = 4 [
      if a-id = 0 [ 
        set stop-for-decision 1 
        clear-output ] ]
    if question-id = 5 [
      if a-id = 0 and [ account ] of one-of houses >= [ household-threshold ] of one-of houses [ 
        set stop-for-decision 1 ] 
      ]
end

to CALENDAR
  ;; months: "janv" "févr" "mars" "avril" "mai" "juin" "juil" "août" "sept" "oct" "nov" "déc"
  if any? coffees with [ harvested-this-year = true ] and month-text = "févr" [ 
    ask coffees with [ harvested-this-year = true ] [
      set harvested-this-year 0
    ]
  ]
  if ticks mod 2160 = 0 [
    if any? huile-de-palms with [ harvested-this-year = true ] [ 
      ask huile-de-palms with [ harvested-this-year = true ] [
      set harvested-this-year 0
      ]
    ]
  ]
  if ticks mod 8640 = 0 and any? patches with [ crop = "huile-de-palm" ] [
    let c count patches with [ crop = "huile-de-palm" ]
    ask one-of houses [ set account account - ( ( c / 300 * 25000) ) ]
  ]
   
  ask farmers [
    if hour-in-day = 1 and member? month-text [ "janv" "févr" "mars" ] [
      if any? patches with [ member? use [ "farmland" "forest" ] and state = "wild" and communally-owned? = 0 and crop != 0 ] and day-in-month > travail-communal [
        set action "prepare-soil"
      ]
    ]
  ]
  ask farmers with [ health >= 0 ] [
    if member? month-text [ "mars" "avril" ] and any? patches with [ state = "prepared" ] and day-in-month > travail-communal [
      set action "sowing seeds" ] ] 
  
  ask farmers with [ health >= 0 ] [
    prepare-soil
    sow-seeds
    harvest-crops ]
  
  if day-in-month <= travail-communal [
    if hour-in-day = 2 and member? month-text ["janv" "févr" "mars" "avril" "mai" "juin" "juil" "août" "sept" "oct" "nov" "déc" ] 
    and any? patches with [ communally-owned? = true and state = "wild" ] [
      ask farmers [ set action "prepare-communal-field" ] ]
        ]
  prepare-communal-field
  ;sow-communal-field
    
  if any? tractors and day-in-month > travail-communal and member? month-text [ "janv" "févr" ] [
    ask tractors [ 
      set hired-duration hired-duration + 1
      if hired-duration = 300 [ die ]
      drive-tractor ]
    ]
  if any? farmers with [ action = 0 ] [ 
    ask farmers [ move-to my-home ] ]
  
  if member? month-text [ "sept" ] and hour-in-day = 1 and any? harvested-maizes [
    ask farmers [ set action "burn-maize" ] ]
  burn-maize
  
  if hour-in-day = 3 and ticks > 10 [
    if any? farmers with [ action = 0 and health >= 0 ] [
      let a random 100
      ask farmers  with [ action = 0 and health >= 0 ] [
        while [ action = 0 ] [
          if a < 33  [ set action "worship" ]
          if a >= 33 and a < 66 [ set action "worship" ]
          if a >= 66 and a < 100 [ set action "shop" ] ] ] ] ]
  if not any? farmers with [ action = "worship" ] [
    if any? music-notes [
      ask music-notes [ die ] ] ]
  socialise
  worship
  shop
  fields-turn-wild
  maize-dies-if-too-old
end

to maize-dies-if-too-old
  ; presumably all the other crops have a finite life in the fields too?
  if any? maizes and month-text = "août" [
    ask maizes [
      ask patch-here [ set state "prepared" ]
      hatch-harvested-maizes 1 [
      set shape "plant"
      set size 1
      set color 42
      set heading 45 + random 45
      ]
      die
    ]
  ]   
end

to fields-turn-wild
  if ticks mod 168 = 0 [
    if any? patches with [ state = "prepared" ] [
      ask patches with [ state = "prepared" ] [
        set time-til-last-prepared-in-weeks time-til-last-prepared-in-weeks + 1 ]
    ]
  ]
  if any? patches with [ time-til-last-prepared-in-weeks >= 18 ] [
    ask patches with [ time-til-last-prepared-in-weeks >= 18 ] [
      set time-til-last-prepared-in-weeks 0
      set state "wild"
      if crop = "maize" [ set pcolor 52 + 2 ]
      if crop = "manioc" [ set pcolor 52 + 3 ]
      if crop = "peanut" [ set pcolor 52 + 4 ]
      if crop = "coffee" [ set pcolor 52 + 1 ]
    ]
  ]
end

to drive-cars
  if any? cars [ ; car stops and starts
    ask cars [
      set age age - 1
      if age <= -150 [ set age 300 ]
      ifelse age >= 0 
      [ set driving? true ]
      [ set driving? false ]
    ]
  ]
  ask cars with [ driving? = true ] [
    let vision patches in-cone 3 50 with [ use = "road" ]
    let b random 10
    ifelse any? vision with [ use = "road"] 
    [
      face max-one-of vision with [ use = "road"] [ distance myself ]
      let a count patches in-radius 3
      if a > 4 [ ask n-of ( a / 4 ) patches in-radius 5 [ sprout-lights 1 [ set shape "star" set size random-float .8 set color [ pcolor ] of myself + 3 ] ] ]
      fd random-float .5
      ]
    [
      rt 90 + random 180
      ]
    ]
  ask cars [
    if [ use ] of patch-here != "road" [
      move-to min-one-of patches with [ use = "road" ] [ distance myself ]
    ]
  ]
  if any? lights [
    ask lights [ 
      set age age + 1
      set heading random 360
      fd 1
      if age >= 10 [ die ]
      ]
  ]
end

to play-sound-recording [ q-id ]
  sound:play-sound-and-wait word question-id ".wma" 
  show word question-id ".wma" 
end

to make-lots-of-png-images
  if record? = true [
    display
    export-interface (word "person-name-folder" "/frame" ; person-name-directory e.g. a folder where NL installed called howard-noble
                        but-first ( word ( 100000 + round ticks ) ) ".png")
  ]
end

to SOW-SEEDS
  ask farmers with [ action = "sowing seeds" and health >= 0 ] [
    if hour-in-day = 8 [
      if any? patches with [ state = "prepared" and communally-owned? = 0 ] [ 
        move-to one-of patches with [ state = "prepared" and communally-owned? = 0 ] ]
      if [ crop ] of patch-here = "maïs et pistache" [ 
        let a count patches with [ crop = "maïs et pistache" and state = "prepared" ]
        ifelse a >= pace-sowing-seed
        [
          ask min-n-of pace-sowing-seed patches with [ crop = "maïs et pistache" and state = "prepared" ] [ distance myself ] [
            sprout-maizes 1 [ set time-to-mature 12 set shape "plant" set color 44 set size .5 ]
            sprout-melons 1 [ set time-to-mature 8 set shape "plant" set color 64 set size .5 ]
            set state "seeded"
          ]
        ]
        [
          ask min-n-of a patches with [ crop = "maïs et pistache" and state = "prepared" ] [ distance myself ] [
            sprout-maizes 1 [ set time-to-mature 12 set shape "plant" set color 44 set size .5 ]
            sprout-melons 1 [ set time-to-mature 8 set shape "plant" set color 64 set size .5 ]
            set state "seeded"
          ]
        ]  
      ]
      if [ crop ] of patch-here = "arachide et okra" [
        let a count patches with [ crop = "arachide et okra" and state = "prepared" ]
        ifelse a >=  pace-sowing-seed
        [
          ask min-n-of pace-sowing-seed patches with [ crop = "arachide et okra" and state = "prepared" ] [ distance myself ] [
            sprout-peanuts 1 [ set time-to-mature 12 set shape "plant" set color 44 set size .5 set heading random 360 fd random-float .4 ]
            sprout-okras 1 [ set time-to-mature 12 set shape "plant" set color 64 set size .5 set heading random 360 fd random-float .4 ]
            set state "seeded"
          ]
        ]
        [
          ask min-n-of a patches with [ crop = "arachide et okra" and state = "prepared" ] [ distance myself ] [
            sprout-peanuts 1 [ set time-to-mature 12 set shape "plant" set color 44 set size .5 set heading random 360 fd random-float .4 ]
            sprout-okras 1 [ set time-to-mature 12 set shape "plant" set color 64 set size .5 set heading random 360 fd random-float .4 ]
            set state "seeded"
            ]
        ]
      ]
      if [ crop ] of patch-here = "manioc rouge" [ 
        let a count patches with [ crop = "manioc rouge" and state = "prepared" ]
        ifelse a >= pace-sowing-seed
        [
          ask min-n-of pace-sowing-seed patches with [ crop = "manioc rouge" and state = "prepared" ] [ distance myself ] [
            sprout-manioc-rouges 1 [ set time-to-mature 52 set shape "plant" set color 16 set size .5 ]
            set state "seeded"
          ]
        ]
        [
          ask min-n-of a patches with [ crop = "manioc rouge" and state = "prepared" ] [ distance myself ] [
            sprout-manioc-rouges 1 [ set time-to-mature 52 set shape "plant" set color 16 set size .5 ]
            set state "seeded"
          ]
        ]
      ]
      if [ crop ] of patch-here = "manioc blanc" [ 
        let a count patches with [ crop = "manioc blanc" and state = "prepared" ]
        ifelse a >= pace-sowing-seed
        [
          ask min-n-of pace-sowing-seed patches with [ crop = "manioc blanc" and state = "prepared" ][ distance myself ] [
            sprout-manioc-blancs 1 [ set time-to-mature 36 set shape "plant" set color 69 set size .5 ]
            set state "seeded"
          ]
        ]
        [
          ask min-n-of a patches with [ crop = "manioc blanc" and state = "prepared" ][ distance myself ] [
            sprout-manioc-blancs 1 [ set time-to-mature 36 set shape "plant" set color 69 set size .5 ]
            set state "seeded"
          ]
        ]
      ]
      if [ crop ] of patch-here = "maïs" [ 
        let a count patches with [ crop = "maïs" and state = "prepared" ]
        ifelse a >= pace-sowing-seed
        [
          ask min-n-of pace-sowing-seed patches with [ crop = "maïs" and state = "prepared" ][ distance myself ] [
            sprout-maizes 1 [ set time-to-mature 12 set shape "plant" set color 16 set size .5 ]
            set state "seeded"
          ]
        ]
        [
          ask min-n-of a patches with [ crop = "maïs" and state = "prepared" ][ distance myself ] [
            sprout-maizes 1 [ set time-to-mature 12 set shape "plant" set color 16 set size .5 ]
            set state "seeded"
          ]
        ]
      ]
      if [ crop ] of patch-here = "cafe" [
        let a count patches with [ crop = "cafe" and state = "prepared" ] 
        ifelse a >= pace-sowing-seed
        [
          ask min-n-of pace-sowing-seed patches with [ crop = "cafe" and state = "prepared" ] [ distance myself ] [
            sprout-coffees 1 [ set time-to-mature ( 208 ) set shape "tree" set color 36 set size .5 ]
            set state "seeded"
          ]
        ]
        [
          ask min-n-of a patches with [ crop = "cafe" and state = "prepared" ] [ distance myself ] [
            sprout-coffees 1 [ set time-to-mature ( 208 ) set shape "tree" set color 36 set size .5 ]
            set state "seeded"
          ]
        ]
      ]
      if [ crop ] of patch-here = "huile de palme" [ 
        let a count patches with [ crop = "huile de palme" and state = "prepared" ] 
        ifelse a >= pace-sowing-seed
        [
          ask min-n-of pace-sowing-seed patches with [ crop = "huile de palme" and state = "prepared" ] [ distance myself ] [
            sprout-huile-de-palms 1 [ set time-to-mature ( 208 ) set shape "tree pine" set color 24 set size .5 ]
            set state "seeded"
            let z [ pace-sowing-seed ] of one-of farmers
            ask one-of houses [ set account account - ( z * 1000 ) ]
          ]
        ]
        [
          ask min-n-of a patches with [ crop = "huile de palme" and state = "prepared" ] [ distance myself ] [
            sprout-huile-de-palms 1 [ set time-to-mature ( 208 ) set shape "tree pine" set color 24 set size .5 ]
            set state "seeded"
            ask one-of houses [ set account account - ( a * 1000 ) ]
          ]
        ]
      ]
    ]
    if hour-in-day = 18 [ set action 0 ]
  ]
end

to HARVEST-CROPS
  if hour-in-day = 8 [
    if any? turtles with [ 
      member? breed ( list maizes manioc-rouges manioc-blancs peanuts melons okras melons coffees huile-de-palms  ) 
      and age-weeks >= time-to-mature and 
      harvested-this-year != true ] [
      
      set action "harvest-crop"
      let harvest-target one-of turtles with [ member? breed ( list maizes manioc-rouges manioc-blancs peanuts melons coffees huile-de-palms okras melons ) and age-weeks >= time-to-mature and harvested-this-year != true ]
      move-to harvest-target 
      let a count turtle-set [ breed ] of harvest-target
      ifelse a >= pace-harvesting-crop 
      [
        let b min-n-of pace-harvesting-crop turtle-set [ breed ] of harvest-target [ distance myself ]
           if member? harvest-target maizes [ set maize-store maize-store + ( pace-harvesting-crop / 300 ) * item maize-yield-variation hectare-yield-maize ] 
           if member? harvest-target manioc-rouges [ set manioc-rouge-store manioc-rouge-store + ( pace-harvesting-crop / 300 ) * 60 ]
           if member? harvest-target manioc-blancs [ set manioc-blanc-store manioc-blanc-store + ( pace-harvesting-crop / 300 ) * item manioc-blanc-yield-variation hectare-yield-manioc-blanc ]
           if member? harvest-target peanuts [ set peanut-store peanut-store + ( pace-harvesting-crop / 300 ) * item peanut-yield-variation hectare-yield-peanut ]
           if member? harvest-target okras [ set okra-store okra-store + ( pace-harvesting-crop / 300 ) * 3 ]
           if member? harvest-target melons [ set melon-store melon-store + ( pace-harvesting-crop / 300 ) * 3 ]
           if member? harvest-target coffees [ set coffee-store coffee-store + ( pace-harvesting-crop / 300 ) * item coffee-yield-variation hectare-yield-coffee ]
           if member? harvest-target huile-de-palms [ set huile-de-palm-store huile-de-palm-store + ( pace-harvesting-crop / 300 ) * 50 ] ; warping space to get planting density
           foreach sort b [
             ask ? [
               ifelse member? breed ( list maizes manioc-rouges manioc-blancs peanuts melons okras ) 
               [ 
                 die 
                 ]
               [
                 set harvested-this-year true 
                 ] 
               ]
           ]
      ]
      [
        let b min-n-of a turtle-set [ breed ] of harvest-target [ distance myself ]
           if member? harvest-target maizes [ set maize-store maize-store + ( a / 300 ) * item maize-yield-variation hectare-yield-maize  ]
           if member? harvest-target manioc-rouges [ set manioc-rouge-store manioc-rouge-store + ( a / 300 ) * 60]
           if member? harvest-target manioc-blancs [ set manioc-blanc-store manioc-blanc-store + ( a / 300 ) * item manioc-blanc-yield-variation hectare-yield-manioc-blanc ]
           if member? harvest-target peanuts [ set peanut-store peanut-store + ( a / 300 ) * item peanut-yield-variation hectare-yield-peanut ]
           if member? harvest-target coffees [ set coffee-store coffee-store + ( a / 300 ) * item coffee-yield-variation hectare-yield-coffee ]
           if member? harvest-target okras [ set okra-store okra-store + ( a / 300 ) * 3]
           if member? harvest-target melons [ set melon-store melon-store + ( a / 300 ) * 3]
           if member? harvest-target huile-de-palms [ set huile-de-palm-store huile-de-palm-store + ( a / 300 ) * 3 ]
           foreach sort b [
             ask ? [
               ifelse member? breed ( list maizes manioc-rouges manioc-blancs peanuts melons okras ) 
               [ 
                 die 
                 ]
               [
                 set harvested-this-year true 
                 ] 
               ]
           ] 
        ]
      ]
    ]
end

to crops-age
  if any? turtles with [ member? breed ( list maizes manioc-blancs manioc-rouges peanuts melons okras huile-de-palms coffees ) ] [
    ask turtles with [ member? breed ( list maizes manioc-blancs manioc-rouges peanuts melons okras huile-de-palms coffees ) ] [
      if ticks mod 168 = 0 [
        set age-weeks age-weeks + 1 
      ]
    ]
  ]
end

to burn-maize
  ask farmers [
    if action = "burn-maize" [
      go-to-harvested-maize-field
      start-fire
      return-home-after-burning-maize-field
    ]
  ]
end

to go-to-harvested-maize-field
  if any? harvested-maizes [
    ask harvested-maizes [ ask patch-here [ set state "prepared" ] ]
    move-to min-one-of harvested-maizes [ pxcor ]
  ]
end

to start-fire
  if any? harvested-maizes [
    ask min-one-of harvested-maizes [ distance myself ] [
      hatch-burning-maizes 1 [ set shape "fire" set size 0.3 set color yellow ]
      die
      ]
    ]
end

to return-home-after-burning-maize-field
  if hour-in-day = 20 [
    move-to my-home
    set action 0
  ]
end

to fire-spreads
  if ticks mod 10 = 0 [ 
    if any? burning-maizes [
      ask burning-maizes [
        if random 100 > 90 [ ask one-of burning-maizes [ set heading random 360 set spark? true ] ]
        if spark? = true [ 
          fd 5 
          set heading heading - ( 30 - random 60 )
          if any? turtles with [ member? breed (list coffees huile-de-palms ) ] in-radius 5 [ 
              ask turtles with [ member? breed (list coffees huile-de-palms ) ] in-radius 5 [ 
                ask patch-here [ 
                  set state "wild"
                  set pcolor 62 ]
                die ] ] ]
        set size size + random-float .5
        if size >= 2 [ 
          die ]
        let a 1 + random 3
        let b count neighbors with [ any? harvested-maizes-here ]
        ifelse a >= b 
        [
          ask n-of a neighbors [
            if any? harvested-maizes-here [
              sprout-burning-maizes 1 [
                set shape "fire"
                set size .3
                set color yellow ]
              ask harvested-maizes-here [ die ]
            ]
          ]
        ]
        [
          ask n-of b neighbors [
            if any? harvested-maizes-here [
              sprout-burning-maizes 1 [
                set shape "fire"
                set size .3
                set color yellow ]
              ask harvested-maizes-here [ die ]
            ]
          ]
        ]
        ]
    ]
  ]
end

to MAKE-FIELDS
  if not member? crop-choice ( list "cafe" "huile de palme" ) [
  let a 52 + random-float 6
  if any? patches with [ use = "farmland" and crop = 0 and communally-owned? = 0 ] [
    ifelse count patches with [ use = "farmland" and crop = 0 and communally-owned? = 0 ] >= ( quantite * 300 )
    [
      ask min-n-of ( quantite * 300 ) patches with [ use = "farmland" and crop = 0 and communally-owned? = 0 ] [ pycor ] [ 
        set crop crop-choice 
        set pcolor a ]
      ask one-of patches with [ crop = crop-choice and pcolor = a and any? neighbors with [ use = "river" ] ] [ set plabel crop-choice ]
      ]
    [
      ask patches with [ use = "farmland" and crop = 0 and communally-owned? = 0 ] [ 
        set crop crop-choice 
        set pcolor a ]
      ask one-of patches with [ crop = crop-choice and any? neighbors with [ use = "river" ] ] [ set plabel crop-choice ]
      ]
    ]
  ]
  if member? crop-choice ( list "cafe" "huile de palme" ) [
  let a 52 + random-float 6
  if any? patches with [ use = "forest" and crop = 0 ] [
    ifelse count patches with [ use = "forest" and crop = 0 ] >= ( quantite * 300 )
    [
      if any? trees with [ [ crop] of patch-here = 0 ] [
        ask one-of trees with [ [ crop] of patch-here = 0 ] [ 
          ask min-n-of ( quantite * 300 ) patches with [ use = "forest" and crop = 0 ] [ distance myself ] [
            set crop crop-choice 
            set pcolor a ]
          set label crop-choice
          ]
      ]
    ]
    [
      let b patches with [ use = "forest" and crop = 0 ]
      ask one-of trees with [ [ crop] of patch-here = 0 ] [ 
        ask b [
          set crop crop-choice 
          set pcolor a ]
        set label crop-choice
      ]
      ]
    ]
  ]
end

to clock
  set hour-in-day hour-in-day + 1
  if ticks mod 24 = 0 [ 
    set hour-in-day 1
    set day-in-week day-in-week + 1 
    set day-in-month day-in-month + 1 
    set day-in-year day-in-year + 1
    ]
  if ticks mod 720 = 0 [ set month-in-year month-in-year + 1 ]
  if ticks mod 8640 = 0 and ticks != 0 [ set year year + 1 ]
  if ticks mod 168 = 0 [ set day-in-week 1 ]
  if ticks mod 720 = 0 [ set day-in-month 1 ]
  if ticks mod 8640 = 0 [ set day-in-year 1 ]
  if ticks mod 8640 = 0 [ set month-in-year 1 ]

  set weekdays-text item ( day-in-week - 1 ) weekdays
  set month-text item ( month-in-year - 1 ) months
end

to cow-movement
  ask cows [
    if wandering? = false [
      if ticks mod 10 = 0 [
        fd random-float 3
        set heading random 360
      ]
      if [ use ] of patch-here != "wilds" [
        face min-one-of patches with [ use = "wilds" ] [ distance myself ] ]
        ]
    if wandering? = true [ 
      set heading 270 + ( 90 - random 180 )
      fd random-float .5
      if any? farmers in-radius 20 or any? fences in-radius 1 or any? tractors in-radius 20 [ set wandering? false ]
      if any? turtles with [ member? breed (list maizes manioc-rouges manioc-rouges peanuts melons okras ) ] in-radius 2 [ 
        ask turtles with [ member? breed ( list maizes manioc-rouges manioc-rouges peanuts melons okras ) ] in-radius 2 [ 
          ask patch-here [ set state "prepared" ]
          die ] ] ]
    ]      
end

to read-in-climate-model-weather-data
  file-open "rainfall-1961-2000.txt" ; monthly weather data for now and 100 years in future
  while [ not file-at-end? ]
  [
    set rain-data-1961-2000 ( sentence rain-data-1961-2000 (list  file-read ) )
    ]
  file-close
  set rain-data-1961-2000 remove-item 0 rain-data-1961-2000
  
  file-open "rainfall-2046-2065.txt"
  while [ not file-at-end? ]
  [
    set rain-data-2046-2065 sentence rain-data-2046-2065 (list file-read )
    ]
  file-close
  set rain-data-2046-2065 remove-item 0 rain-data-2046-2065
  
  file-open "rainfall-2081-2100.txt"
  while [ not file-at-end? ]
  [
    set rain-data-2081-2100 sentence rain-data-2081-2100 (list file-read )
    ]
  file-close
  set rain-data-2081-2100 remove-item 0 rain-data-2081-2100
  
  file-open "temp-20th-century.txt" ; monthly weather data for now and 100 years in future
  while [ not file-at-end? ]
  [
    set temperature-data-20th-century ( sentence temperature-data-20th-century (list  file-read ) )
    ]
  file-close
  set temperature-data-20th-century remove-item 0 temperature-data-20th-century
  
  file-open "temp-2046-2065.txt"
  while [ not file-at-end? ]
  [
    set temperature-data-2046-2065 sentence temperature-data-2046-2065 (list file-read )
    ]
  file-close
  set temperature-data-2046-2065 remove-item 0 temperature-data-2046-2065
  file-open "temp-2081-2100.txt"
  while [ not file-at-end? ]
  [
    set temperature-data-2081-2100 sentence temperature-data-2081-2100 (list file-read )
    ]
  file-close
  set temperature-data-2081-2100 remove-item 0 temperature-data-2081-2100
end

to add-disasters
  ; some of farmers become ill
  if ticks mod 8736 = 0 [
  if random 100 > 80 [
    clear-output
    output-print "Il y a de la maladie dans la famille"
    output-print "Il faut rester dans la maison."
    output-print "Vous-pouvez acheter les medicine!"
    ask one-of farmers [ set health -200 ] ] ]
  if any? farmers with [ health < 0 ] [
    ask farmers with [ health < 0 ] [ set health health + 1 ] ]
  
  ; strong winds damage maize
  if ticks mod 8736 = 0 [
    if random 100 > 50 and any? turtles with [ member? breed ( list maizes ) ]  [
      let epicentre one-of turtles with [ member? breed ( list maizes ) ]
      ask epicentre [ 
        let c count turtles with [ member? breed ( list maizes  ) ] in-radius 10 
          ifelse c >= 20
            [
              ask n-of 20 turtles with [ member? breed ( list maizes ) ] in-radius 10 [ set heading 90 ]
              ]
            [
              ask n-of c turtles with [ member? breed ( list maizes ) ] in-radius 10 [ set heading 90 ]
              ]
            clear-output
            output-print ( word "Vents forts ont destroyer quelque " [ breed ] of epicentre )
            ]
          ]
    ]
  ; theft
  if ticks mod 8376 = 0 [
    if random 100 > 80 [
      ifelse maize-store >= 1
      [
        set maize-store maize-store - 1
      ]
      [
        
      ]
      clear-output
      output-print "En a volé un sac de maïs du grenier"
    ]
  ]
  ; fencing rots
  if ticks mod 8376 = 0 and random 100 > 80 [ 
    if any? fences [
      let c count fences
      ifelse c >= 30 
      [
        ask one-of fences [ 
          ask min-n-of 20 fences [ distance myself ] [ die ]
        ]
      ]
      [
        ask one-of fences [
          ask min-n-of ( c - 1 ) fences [ distance myself ] [ die ]
        ]
      ]
      clear-output
      output-print "Attention les vaches ont depasse l'ancien clôture qui a tombee!"
    ]
  ]
end

to buy-something
  if quelque-chose = "clôture" [ 
    ask houses [ set account account - 300 ]
    make-fencing ]
  if quelque-chose = "tracteur" [ 
    ask houses [ set account account - 6000 ] 
    introduce-tractor ]
  if quelque-chose = "maïs" [ 
    ask houses [ set account account - item maize-price-variation price-maize ]
    set maize-store maize-store + 1 ]
  if quelque-chose = "médecine" [ 
    ask houses [ set account account - 5000 ]
    if any? farmers with [ health < 0 ] [ 
      ask farmers  with [ health < 0 ] [ set health 0 ]
    ]
  ]
  if quelque-chose = "tole" [ 
    ask one-of houses [ 
      set account account - 150000 
      set color white ]
    ]
end

to SELL-SOMETHING
  ; this is crude! should either be a lookup to historical data, a market equation, or a combination of the two
 ; let current-price-maize 21000
  let current-price-coffee 30000
  let current-price-manioc-rouge 2000
  let current-price-manioc-blanc 2000
  let current-price-melon 5000
  let current-price-okra 3000
  let current-price-huile-de-palm 35000
  let current-price-peanut 20000
  
  ask one-of houses [
    if a-vendre = "mais"[
      ifelse ( quantité-vendue * maize-store) <= maize-store
      [
        set account account + ( ( quantité-vendue * maize-store) * item maize-price-variation price-maize )
        set maize-store maize-store - ( quantité-vendue * maize-store) 
      ]
      [
        clear-output
        output-print "Vous n'avez pas suffisamment de mais"
        output-print "Essayez à nouveau"
      ]
    ]  
    if a-vendre = "manioc rouge"[ 
      ifelse ( quantité-vendue * manioc-rouge-store ) <= manioc-rouge-store
      [
        set account account + ( ( quantité-vendue * manioc-rouge-store ) * current-price-manioc-rouge ) 
        set manioc-rouge-store manioc-rouge-store - ( quantité-vendue * manioc-rouge-store )
        ]
      [
        clear-output
        output-print "Vous n'avez pas suffisamment manioc"
        output-print "Essayez à nouveau"
        ]
    ]    
    if a-vendre = "manioc blanc"[ 
      ifelse ( quantité-vendue * manioc-blanc-store) <= manioc-blanc-store
      [
        set account account + ( ( quantité-vendue * manioc-blanc-store ) * item manioc-blanc-price-variation price-manioc-blanc )
        set manioc-blanc-store manioc-blanc-store - ( quantité-vendue * manioc-blanc-store) 
        ]
      [
        clear-output
        output-print "Vous n'avez pas suffisamment manioc"
        output-print "Essayez à nouveau"
        ]
    ]    
    if a-vendre = "arachide"[ 
      ifelse ( quantité-vendue * peanut-store)  <= peanut-store 
      [
        set account account + ( ( quantité-vendue * peanut-store ) * item peanut-price-variation price-peanut )
        set peanut-store peanut-store - ( quantité-vendue * peanut-store)  
        ]
      [
        clear-output
        output-print "Vous n'avez pas suffisamment arachide"
        output-print "Essayez à nouveau"
        ]
    ]
    if a-vendre = "cafe"[
      ifelse ( quantité-vendue * coffee-store ) <= coffee-store 
      [ 
        set account account + ( ( quantité-vendue * coffee-store ) * item coffee-price-variation price-coffee )
        set coffee-store coffee-store - ( quantité-vendue * coffee-store )
        ]
      [
        clear-output
        output-print "Vous n'avez pas suffisamment cafe"
        output-print "Essayez à nouveau"
        ]
    ]
    if a-vendre = "okra"[
      ifelse ( quantité-vendue * okra-store ) <= okra-store 
      [ 
        set account account + ( ( quantité-vendue * okra-store )  * current-price-okra )
        set okra-store okra-store - ( quantité-vendue * okra-store )   
        ]
      [
        clear-output
        output-print "Vous n'avez pas suffisamment cafe"
        output-print "Essayez à nouveau"
        ]
    ]
    if a-vendre = "pistache"[
      ifelse ( quantité-vendue * melon-store )  <= melon-store 
      [ 
        set account account + ( ( quantité-vendue * melon-store )  * current-price-melon )
        set melon-store melon-store - ( quantité-vendue * melon-store )   
        ]
      [
        clear-output
        output-print "Vous n'avez pas suffisamment cafe"
        output-print "Essayez à nouveau"
        ]
    ]
    if a-vendre = "huile de palme" [
      ifelse ( quantité-vendue * huile-de-palm-store )  <= huile-de-palm-store 
      [ 
        set account account + ( ( quantité-vendue * huile-de-palm-store ) * current-price-huile-de-palm )
        set huile-de-palm-store huile-de-palm-store - ( quantité-vendue * huile-de-palm-store )  
        ]
      [
        clear-output
        output-print "Vous n'avez pas suffisamment huile de palme"
        output-print "Essayez à nouveau"
        ]
    ]
  ]
end

to introduce-tractor
  create-tractors 1 [ 
    set shape "truck cab top" 
    set size 5 
    set color red
    move-to one-of patches with [ use = "road" ]
  ]
end

to DRIVE-TRACTOR
  if hour-in-day = 6 [ 
    ask tractors [ clear-field-with-tractor ] ]
end

to clear-field-with-tractor
  let work-to-do count patches with [ use = "farmland" and state = "wild" and communally-owned? = 0 and crop != 0 ]
  if work-to-do >= 1 [
    move-to min-one-of patches with [ use = "farmland" and state = "wild" and communally-owned? = 0 and crop != 0 ] [ distance myself ]
    ifelse work-to-do >= pace-preparing-soil-with-tractor
      [
        ask min-n-of pace-preparing-soil-with-tractor patches with [ use = "farmland" and communally-owned? = 0 and crop != 0 ] [ distance myself ] [
          set state "prepared"
          set pcolor 32 ]
        ]
      [
        ask min-n-of work-to-do patches with [ use = "farmland" and communally-owned? = 0 and crop != 0 ] [ distance myself ] [
          set state "prepared"
          set pcolor 32 ]
        ]
    ]          
end
    
to make-fencing
  let a count patches with [ use = "farmland" and any? neighbors4 with [ use = "river" ] and not any? fences-here ]
  ifelse a >= 10 and a > 0 
  [
    ask max-n-of 10 patches with [ use = "farmland" and any? neighbors4 with [ use = "river" ] and not any? fences-here ] [ pycor ] [
    sprout-fences 1 [ set shape "circle" set color black ] ]
  ]
  [
    ask max-n-of a patches with [ use = "farmland" and any? neighbors4 with [ use = "river" ] and not any? fences-here ] [ pycor ] [
      sprout-fences 1 [ set shape "circle" set color black ] ]
  ]    
  ask fences with [ count my-links < 2 ] [
    let my-pycor pycor
    let my-pxcor pxcor
      if any? fences [
        let north min-one-of fences with [ pycor > my-pycor ] [ distance myself ] 
        let south min-one-of fences with [ pycor < my-pycor ] [ distance myself ] 
        if north != nobody and distance north <= 3 [ create-link-with north ]
        if south != nobody and distance south <= 3 [ create-link-with south ]
      ]
  ]
end

to initialise-yields ; per hectare
  set hectare-yield-maize [ 17 22 ] ; sacks
  set hectare-yield-manioc-rouge [  ]
  set hectare-yield-manioc-blanc [ 16 18 ]
  set hectare-yield-peanut [ 20 30 ]
  set hectare-yield-melon [ ]
  set hectare-yield-okra [ ]
  set hectare-yield-huile-de-palm [ ] 
  set hectare-yield-coffee [ 40 50 ] ; sacks
end

to initialise-prices ; per unit
  ; prices per season:
  ; may-july is high season for maize
  ; 
  set price-maize [ 14000 30000 ] ; sacks
  set price-manioc-rouge [] ; furrow
  set price-manioc-blanc [ 10500 12000 ] ; sacks
  set price-melon []
  set price-peanut [ 12000 20800 ] ; sacks
  set price-coffee [ 30000 40000 ]
  set price-huile-de-palm []
  set price-okra [ ]
end
@#$#@#$#@
GRAPHICS-WINDOW
4
91
509
467
49
34
5.0
1
10
1
1
1
0
1
0
1
-49
49
-34
34
0
0
1
ticks
30.0

BUTTON
810
20
876
53
INSTALLER
setup
NIL
1
T
OBSERVER
NIL
I
NIL
NIL
1

BUTTON
743
20
809
53
ALLER
ifelse stop-for-decision = 1 \n[ go ]\n[ ]
T
1
T
OBSERVER
NIL
L
NIL
NIL
1

OUTPUT
4
10
509
90
12

BUTTON
511
10
566
43
A
answer 0
NIL
1
T
OBSERVER
NIL
A
NIL
NIL
1

MONITOR
573
14
623
59
jour
day-in-month
17
1
11

MONITOR
625
14
687
59
mois
month-text
17
1
11

MONITOR
689
14
739
59
année
year
17
1
11

BUTTON
1164
497
1219
530
écouter
play-sound-recording question-id
NIL
1
T
OBSERVER
NIL
E
NIL
NIL
1

SWITCH
891
497
981
530
record?
record?
1
1
-1000

SWITCH
1072
497
1162
530
nuages?
nuages?
1
1
-1000

BUTTON
661
388
757
421
acheter
buy-something
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

CHOOSER
661
341
757
386
quelque-chose
quelque-chose
"clôture" "tracteur" "maïs" "manioc" "arachide" "médecine" "herbicide" "tole"
2

BUTTON
515
433
611
466
vendre
sell-something
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

CHOOSER
513
341
649
386
a-vendre
a-vendre
"mais" "manioc rouge" "manioc blanc" "arachide" "cafe" "okra" "pistache" "huile de palme"
1

MONITOR
513
225
584
270
maïs (sac)
maize-store
1
1
11

MONITOR
582
225
674
270
arachide (sac)
peanut-store
1
1
11

MONITOR
758
272
827
317
café (sac)
coffee-store
1
1
11

TEXTBOX
513
145
619
163
TERRAIN
11
125.0
1

TEXTBOX
513
82
644
100
TRAVAILLER COMMUNAUX
11
65.0
1

TEXTBOX
665
326
728
344
ACHETER
11
75.0
1

TEXTBOX
514
325
567
343
VENDRE
11
25.0
1

MONITOR
667
102
787
151
ARGENT (CFA)
[ account ] of one-of houses
0
1
12

TEXTBOX
514
209
572
228
RÉSERVE
11
75.0
1

SWITCH
981
497
1071
530
cars?
cars?
1
1
-1000

BUTTON
511
45
566
78
B
answer 1
NIL
1
T
OBSERVER
NIL
B
NIL
NIL
1

CHOOSER
513
162
660
207
crop-choice
crop-choice
"maïs et pistache" "arachide et okra" "manioc rouge" "manioc blanc" "maïs" "cafe" "huile de palme"
0

BUTTON
817
162
883
195
choisi
make-fields
NIL
1
T
OBSERVER
NIL
D
NIL
NIL
1

MONITOR
513
271
600
316
pistache(sac)
melon-store
1
1
11

MONITOR
589
271
683
316
okra (seau)
okra-store
1
1
11

MONITOR
686
272
756
317
palm (kg)
huile-de-palm-store
1
1
11

MONITOR
784
225
879
270
manioc-blanc(sac)
manioc-blanc-store
1
1
11

MONITOR
676
225
783
270
manioc-rouge (sillon)
manioc-rouge-store
0
1
11

CHOOSER
670
162
808
207
quantite
quantite
0.25 0.5 0.75 1 1.5 2 3
6

CHOOSER
512
98
650
143
travail-communal
travail-communal
1 2 4 6 8 10
2

CHOOSER
514
387
652
432
quantité-vendue
quantité-vendue
0.25 0.5 0.75 1
2

PLOT
890
10
1289
491
argent (CFA)
NIL
NIL
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"argent" 1.0 0 -14070903 false "" "plot [ account ] of one-of houses"

TEXTBOX
878
494
1236
532
;
11
0.0
0

@#$#@#$#@
## WHAT IS IT?

take away price of fields (choisi terraire)
maize burning dec-jan-feb
weekly market on sat
variation in rainfall either side of the village - manioc farming!
add wind and bad health and other disasters - decision to grow less maize, maybe more manioc
show kudos points for working in the communal field
check laptop speakers
remove the 8 UI widgets
motorbike

## HOW IT WORKS

(what rules the agents use to create the overall behavior of the model)

## HOW TO USE IT

(how to use the model, including a description of each of the items in the Interface tab)

## THINGS TO NOTICE

(suggested things for the user to notice while running the model)

## THINGS TO TRY

(suggested things for the user to try to do (move sliders, switches, etc.) with the model)

## EXTENDING THE MODEL

(suggested things to add or change in the Code tab to make the model more complicated, detailed, accurate, etc.)

## NETLOGO FEATURES

(interesting or unusual features of NetLogo that the model uses, particularly in the Code tab; or where workarounds were needed for missing features)

## RELATED MODELS

(models in the NetLogo Models Library and elsewhere which are of related interest)

## CREDITS AND REFERENCES

(a reference to the model's URL on the web if it has one, as well as any other necessary credits, citations, and links)
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

building store
false
0
Rectangle -7500403 true true 30 45 45 240
Rectangle -16777216 false false 30 45 45 165
Rectangle -7500403 true true 15 165 285 255
Rectangle -16777216 true false 120 195 180 255
Line -7500403 true 150 195 150 255
Rectangle -16777216 true false 30 180 105 240
Rectangle -16777216 true false 195 180 270 240
Line -16777216 false 0 165 300 165
Polygon -7500403 true true 0 165 45 135 60 90 240 90 255 135 300 165
Rectangle -7500403 true true 0 0 75 45
Rectangle -16777216 false false 0 0 75 45

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
true
0
Polygon -7500403 true true 180 0 164 21 144 39 135 60 132 74 106 87 84 97 63 115 50 141 50 165 60 225 150 300 165 300 225 300 225 0 180 0
Circle -16777216 true false 180 30 90
Circle -16777216 true false 180 180 90
Polygon -16777216 true false 80 138 78 168 135 166 135 91 105 106 96 111 89 120
Circle -7500403 true true 195 195 58
Circle -7500403 true true 195 47 58

chess bishop
false
0
Circle -7500403 true true 135 35 30
Circle -16777216 false false 135 35 30
Rectangle -7500403 true true 90 255 210 300
Line -16777216 false 75 255 225 255
Rectangle -16777216 false false 90 255 210 300
Polygon -7500403 true true 105 255 120 165 180 165 195 255
Polygon -16777216 false false 105 255 120 165 180 165 195 255
Rectangle -7500403 true true 105 165 195 150
Rectangle -16777216 false false 105 150 195 165
Line -16777216 false 137 59 162 59
Polygon -7500403 true true 135 60 120 75 120 105 120 120 105 120 105 90 90 105 90 120 90 135 105 150 195 150 210 135 210 120 210 105 195 90 165 60
Polygon -16777216 false false 135 60 120 75 120 120 105 120 105 90 90 105 90 135 105 150 195 150 210 135 210 105 165 60

chess king
false
0
Polygon -7500403 true true 105 255 120 90 180 90 195 255
Polygon -16777216 false false 105 255 120 90 180 90 195 255
Polygon -7500403 true true 120 85 105 40 195 40 180 85
Polygon -16777216 false false 119 85 104 40 194 40 179 85
Rectangle -7500403 true true 105 105 195 75
Rectangle -16777216 false false 105 75 195 105
Rectangle -7500403 true true 90 255 210 300
Line -16777216 false 75 255 225 255
Rectangle -16777216 false false 90 255 210 300
Rectangle -7500403 true true 165 23 134 13
Rectangle -7500403 true true 144 0 154 44
Polygon -16777216 false false 153 0 144 0 144 13 133 13 133 22 144 22 144 41 154 41 154 22 165 22 165 12 153 12

chess pawn
false
0
Circle -7500403 true true 105 65 90
Circle -16777216 false false 105 65 90
Rectangle -7500403 true true 90 255 210 300
Line -16777216 false 75 255 225 255
Rectangle -16777216 false false 90 255 210 300
Polygon -7500403 true true 105 255 120 165 180 165 195 255
Polygon -16777216 false false 105 255 120 165 180 165 195 255
Rectangle -7500403 true true 105 165 195 150
Rectangle -16777216 false false 105 150 195 165

chess queen
false
0
Circle -7500403 true true 140 11 20
Circle -16777216 false false 139 11 20
Circle -7500403 true true 120 22 60
Circle -16777216 false false 119 20 60
Rectangle -7500403 true true 90 255 210 300
Line -16777216 false 75 255 225 255
Rectangle -16777216 false false 90 255 210 300
Polygon -7500403 true true 105 255 120 90 180 90 195 255
Polygon -16777216 false false 105 255 120 90 180 90 195 255
Rectangle -7500403 true true 105 105 195 75
Rectangle -16777216 false false 105 75 195 105
Polygon -7500403 true true 120 75 105 45 195 45 180 75
Polygon -16777216 false false 120 75 105 45 195 45 180 75
Circle -7500403 true true 180 35 20
Circle -16777216 false false 180 35 20
Circle -7500403 true true 140 35 20
Circle -16777216 false false 140 35 20
Circle -7500403 true true 100 35 20
Circle -16777216 false false 99 35 20
Line -16777216 false 105 90 195 90

chess rook
false
0
Rectangle -7500403 true true 90 255 210 300
Line -16777216 false 75 255 225 255
Rectangle -16777216 false false 90 255 210 300
Polygon -7500403 true true 90 255 105 105 195 105 210 255
Polygon -16777216 false false 90 255 105 105 195 105 210 255
Rectangle -7500403 true true 75 90 120 60
Rectangle -7500403 true true 75 84 225 105
Rectangle -7500403 true true 135 90 165 60
Rectangle -7500403 true true 180 90 225 60
Polygon -16777216 false false 90 105 75 105 75 60 120 60 120 84 135 84 135 60 165 60 165 84 179 84 180 60 225 60 225 105

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cloud
false
0
Circle -7500403 true true 13 118 94
Circle -7500403 true true 86 101 127
Circle -7500403 true true 51 51 108
Circle -7500403 true true 118 43 95
Circle -7500403 true true 158 68 134

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

egg
false
0
Circle -7500403 true true 96 76 108
Circle -7500403 true true 72 104 156
Polygon -7500403 true true 221 149 195 101 106 99 80 148

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fire
false
0
Polygon -7500403 true true 151 286 134 282 103 282 59 248 40 210 32 157 37 108 68 146 71 109 83 72 111 27 127 55 148 11 167 41 180 112 195 57 217 91 226 126 227 203 256 156 256 201 238 263 213 278 183 281
Polygon -955883 true false 126 284 91 251 85 212 91 168 103 132 118 153 125 181 135 141 151 96 185 161 195 203 193 253 164 286
Polygon -2674135 true false 155 284 172 268 172 243 162 224 148 201 130 233 131 260 135 282

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
3
Rectangle -955883 true false 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -6459832 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

house colonial
false
0
Rectangle -7500403 true true 270 75 285 255
Rectangle -7500403 true true 45 135 270 255
Rectangle -16777216 true false 124 195 187 256
Rectangle -16777216 true false 60 195 105 240
Rectangle -16777216 true false 60 150 105 180
Rectangle -16777216 true false 210 150 255 180
Line -16777216 false 270 135 270 255
Polygon -7500403 true true 30 135 285 135 240 90 75 90
Line -16777216 false 30 135 285 135
Line -16777216 false 255 105 285 135
Line -7500403 true 154 195 154 255
Rectangle -16777216 true false 210 195 255 240
Rectangle -16777216 true false 135 150 180 180

house efficiency
false
0
Rectangle -7500403 true true 180 90 195 195
Rectangle -7500403 true true 90 165 210 255
Rectangle -16777216 true false 165 195 195 255
Rectangle -16777216 true false 105 202 135 240
Polygon -7500403 true true 225 165 75 165 150 90
Line -16777216 false 75 165 225 165

house ranch
false
0
Rectangle -7500403 true true 270 120 285 255
Rectangle -7500403 true true 15 180 270 255
Polygon -7500403 true true 0 180 300 180 240 135 60 135 0 180
Rectangle -16777216 true false 120 195 180 255
Line -7500403 true 150 195 150 255
Rectangle -16777216 true false 45 195 105 240
Rectangle -16777216 true false 195 195 255 240
Line -7500403 true 75 195 75 240
Line -7500403 true 225 195 225 240
Line -16777216 false 270 180 270 255
Line -16777216 false 0 180 300 180

lander
true
0
Polygon -7500403 true true 45 75 150 30 255 75 285 225 240 225 240 195 210 195 210 225 165 225 165 195 135 195 135 225 90 225 90 195 60 195 60 225 15 225 45 75

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

music notes 1
false
0
Polygon -7500403 true true 75 210 96 212 118 218 131 229 135 238 135 243 131 251 118 261 96 268 75 270 55 268 33 262 19 251 15 242 15 238 19 229 33 218 54 212
Rectangle -7500403 true true 120 90 135 255
Polygon -7500403 true true 225 165 246 167 268 173 281 184 285 193 285 198 281 206 268 216 246 223 225 225 205 223 183 217 169 206 165 197 165 193 169 184 183 173 204 167
Polygon -7500403 true true 120 60 120 105 285 45 285 0
Rectangle -7500403 true true 270 15 285 195

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

person doctor
false
0
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Polygon -13345367 true false 135 90 150 105 135 135 150 150 165 135 150 105 165 90
Polygon -7500403 true true 105 90 60 195 90 210 135 105
Polygon -7500403 true true 195 90 240 195 210 210 165 105
Circle -7500403 true true 110 5 80
Rectangle -7500403 true true 127 79 172 94
Polygon -1 true false 105 90 60 195 90 210 114 156 120 195 90 270 210 270 180 195 186 155 210 210 240 195 195 90 165 90 150 150 135 90
Line -16777216 false 150 148 150 270
Line -16777216 false 196 90 151 149
Line -16777216 false 104 90 149 149
Circle -1 true false 180 0 30
Line -16777216 false 180 15 120 15
Line -16777216 false 150 195 165 195
Line -16777216 false 150 240 165 240
Line -16777216 false 150 150 165 150

person farmer
false
0
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Polygon -1 true false 60 195 90 210 114 154 120 195 180 195 187 157 210 210 240 195 195 90 165 90 150 105 150 150 135 90 105 90
Circle -7500403 true true 110 5 80
Rectangle -7500403 true true 127 79 172 94
Polygon -13345367 true false 120 90 120 180 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 180 90 172 89 165 135 135 135 127 90
Polygon -6459832 true false 116 4 113 21 71 33 71 40 109 48 117 34 144 27 180 26 188 36 224 23 222 14 178 16 167 0
Line -16777216 false 225 90 270 90
Line -16777216 false 225 15 225 90
Line -16777216 false 270 15 270 90
Line -16777216 false 247 15 247 90
Rectangle -6459832 true false 240 90 255 300

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

sheep
false
15
Circle -1 true true 203 65 88
Circle -1 true true 70 65 162
Circle -1 true true 150 105 120
Polygon -7500403 true false 218 120 240 165 255 165 278 120
Circle -7500403 true false 214 72 67
Rectangle -1 true true 164 223 179 298
Polygon -1 true true 45 285 30 285 30 240 15 195 45 210
Circle -1 true true 3 83 150
Rectangle -1 true true 65 221 80 296
Polygon -1 true true 195 285 210 285 210 240 240 210 195 210
Polygon -7500403 true false 276 85 285 105 302 99 294 83
Polygon -7500403 true false 219 85 210 105 193 99 201 83

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

squirrel
false
0
Polygon -7500403 true true 87 267 106 290 145 292 157 288 175 292 209 292 207 281 190 276 174 277 156 271 154 261 157 245 151 230 156 221 171 209 214 165 231 171 239 171 263 154 281 137 294 136 297 126 295 119 279 117 241 145 242 128 262 132 282 124 288 108 269 88 247 73 226 72 213 76 208 88 190 112 151 107 119 117 84 139 61 175 57 210 65 231 79 253 65 243 46 187 49 157 82 109 115 93 146 83 202 49 231 13 181 12 142 6 95 30 50 39 12 96 0 162 23 250 68 275
Polygon -16777216 true false 237 85 249 84 255 92 246 95
Line -16777216 false 221 82 213 93
Line -16777216 false 253 119 266 124
Line -16777216 false 278 110 278 116
Line -16777216 false 149 229 135 211
Line -16777216 false 134 211 115 207
Line -16777216 false 117 207 106 211
Line -16777216 false 91 268 131 290
Line -16777216 false 220 82 213 79
Line -16777216 false 286 126 294 128
Line -16777216 false 193 284 206 285

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

tree pine
false
0
Rectangle -6459832 true false 120 225 180 300
Polygon -7500403 true true 150 240 240 270 150 135 60 270
Polygon -7500403 true true 150 75 75 210 150 195 225 210
Polygon -7500403 true true 150 7 90 157 150 142 210 157 150 7

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
true
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

truck cab only
false
0
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Rectangle -1 true false 291 158 300 173

truck cab top
true
0
Rectangle -7500403 true true 70 45 227 120
Polygon -7500403 true true 150 8 118 10 96 17 90 30 75 135 75 195 90 210 150 210 210 210 225 195 225 135 209 30 201 17 179 10
Polygon -16777216 true false 94 135 118 119 184 119 204 134 193 141 110 141
Line -16777216 false 130 14 168 14
Line -16777216 false 130 18 168 18
Line -16777216 false 130 11 168 11
Line -16777216 false 185 29 194 112
Line -16777216 false 115 29 106 112
Line -16777216 false 195 225 210 240
Line -16777216 false 105 225 90 240
Polygon -16777216 true false 210 195 195 195 195 150 210 143
Polygon -16777216 false false 90 143 90 195 105 195 105 150 90 143
Polygon -16777216 true false 90 195 105 195 105 150 90 143
Line -7500403 true 210 180 195 180
Line -7500403 true 90 180 105 180
Line -16777216 false 212 44 213 124
Line -16777216 false 88 44 87 124
Line -16777216 false 223 130 193 112
Rectangle -7500403 true true 225 133 244 139
Rectangle -7500403 true true 56 133 75 139
Rectangle -7500403 true true 120 210 180 240
Rectangle -7500403 true true 93 238 210 270
Rectangle -16777216 true false 200 217 224 278
Rectangle -16777216 true false 76 217 100 278
Circle -16777216 false false 135 240 30
Line -16777216 false 77 130 107 112
Rectangle -16777216 false false 107 149 192 210
Rectangle -1 true false 180 9 203 17
Rectangle -1 true false 97 9 120 17

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

van top
true
0
Polygon -7500403 true true 90 117 71 134 228 133 210 117
Polygon -7500403 true true 150 8 118 10 96 17 85 30 84 264 89 282 105 293 149 294 192 293 209 282 215 265 214 31 201 17 179 10
Polygon -16777216 true false 94 129 105 120 195 120 204 128 180 150 120 150
Polygon -16777216 true false 90 270 105 255 105 150 90 135
Polygon -16777216 true false 101 279 120 286 180 286 198 281 195 270 105 270
Polygon -16777216 true false 210 270 195 255 195 150 210 135
Polygon -1 true false 201 16 201 26 179 20 179 10
Polygon -1 true false 99 16 99 26 121 20 121 10
Line -16777216 false 130 14 168 14
Line -16777216 false 130 18 168 18
Line -16777216 false 130 11 168 11
Line -16777216 false 185 29 194 112
Line -16777216 false 115 29 106 112
Line -7500403 false 210 180 195 180
Line -7500403 false 195 225 210 240
Line -7500403 false 105 225 90 240
Line -7500403 false 90 180 105 180

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

wolf
false
0
Polygon -16777216 true false 253 133 245 131 245 133
Polygon -7500403 true true 2 194 13 197 30 191 38 193 38 205 20 226 20 257 27 265 38 266 40 260 31 253 31 230 60 206 68 198 75 209 66 228 65 243 82 261 84 268 100 267 103 261 77 239 79 231 100 207 98 196 119 201 143 202 160 195 166 210 172 213 173 238 167 251 160 248 154 265 169 264 178 247 186 240 198 260 200 271 217 271 219 262 207 258 195 230 192 198 210 184 227 164 242 144 259 145 284 151 277 141 293 140 299 134 297 127 273 119 270 105
Polygon -7500403 true true -1 195 14 180 36 166 40 153 53 140 82 131 134 133 159 126 188 115 227 108 236 102 238 98 268 86 269 92 281 87 269 103 269 113

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 5.0.2
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 1.0 0.0
0.0 1 1.0 0.0
0.2 0 1.0 0.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180

@#$#@#$#@
0
@#$#@#$#@
